<?php

declare(strict_types=1);

namespace Dedi\SyliusBlogPlugin\Entity;

use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @UniqueEntity(fields={"slug"})
 */
class CategoryTranslation extends AbstractReferableTranslation implements CategoryTranslationInterface
{
    protected ?int $id = null;

    /** @Assert\Length(max="255", groups={"default", "sylius"}) */
    protected ?string $slug = null;

    /**
     * @Assert\NotBlank(groups={"default", "sylius"})
     *
     * @Assert\Length(max="255", groups={"default", "sylius"})
     */
    protected ?string $name = null;

    protected ?string $description = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(?string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(?string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): self
    {
        $this->description = $description;

        return $this;
    }
}
