$(document).ready(() => {
    let timeout;

    $('[name*="category[translations]"][name*="[name]"]').on('propertychange input', (event) => {
        clearTimeout(timeout);
        const element = $(event.currentTarget);

        timeout = setTimeout(() => {
            const slugInput = element.parents('.content').find('[name*="[slug]"]');
            const loadableParent = slugInput.parents('.field.loadable');

            if (slugInput.attr('readonly') === 'readonly') {
                return;
            }

            loadableParent.addClass('loading');

            $.ajax({
                type: 'GET',
                url: slugInput.attr('data-url'),
                data: { name: element.val() },
                dataType: 'json',
                accept: 'application/json',
                success(response) {
                    slugInput.val(response.slug);
                    if (slugInput.parents('.field').hasClass('error')) {
                        slugInput.parents('.field').removeClass('error');
                        slugInput.parents('.field').find('.sylius-validation-error').remove();
                    }
                    loadableParent.removeClass('loading');
                },
            });
        }, 1000);
    });

    // there is no need to listen for click on slug modification toggle, because it will be handle by the product one
    // as _slugField.html.twig that renders the slug field is based on the product
});
